#include <bits/stdc++.h>

using namespace std;

int main()
{
    int t;
    cin>>t;
    int n,k;
    cin>>n>>k;
    int a[n];
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    if((n+k)%2==1){
        cout<<"NE"<<endl;
        return 0;
    }
    int l = 0;
    int L = (n+k)/2;
    vector<int> res;
    sort(a,a+n);
    bool uzeo[n] = {};
    for(int i=0;i<n;i++){
        bool nasao = false;
        int tr;
        if(L>0){
        for(int j=0;j<n;j++){
            if(a[j]>=2*l-i && uzeo[j] == false){
                uzeo[j] = true;
                nasao = true;
                tr = a[j];
                break;
            }

        }
        if(nasao){
            L--;
            l++;
            res.push_back(tr);
        }
        }
        else{
            for(int j=0;j<n;j++){
                if(!uzeo[j]){
                    res.push_back(a[j]);
                    uzeo[j] = true;
                    break;
                }
            }
        }
}
int tr = 0;
for(int i=0;i<n;i++){
    if(tr>res[i]) tr--;
    else tr++;
}
if(tr==k){
    cout<<"DA"<<endl;
    if(t==1){
        for(auto u:res) cout<<u<<" ";
    }
}
else{
    cout<<"NE"<<endl;
}
}